package com.objis.demostruts;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * <p>C'est le composant 'Modle' qui cotient simplement le nom de la personne  qui on va dire "Hello!".
 * <p>
 *
 * Dans une application plus avance, ce composant mettrait  jour un stockage persistant
 * avec le nom de la personne, l'utiliserai comme argument d'appel  un POJO, un DAO 
 * ou l'enverrait pour traitement dans un systme distant (Service web, EJB..).
 *
 * @author Douglas MBIANDOU
 */

public class HelloModel {

    // --------------------------------------------------- Instance Variables

    /**
     * La personne  qui on va dire "Hello!"
     */
    private String _person = null;

    // ----------------------------------------------------------- Properties

    /**
     * Retourne la nouvelle personne  qui on va dire "Hello!"
     *
     * @return String la nouvelle personne  qui on va dire "Hello!"
     */
    public String getPerson() {
        return this._person;
    }

    /**
     * Initialise La personne  qui on va dire "Hello!"
     *
     * @param person La nouvelle personne  qui on va dire "Hello!"
     */
    public void setPerson(String person) {

        this._person = person;

    }

    // --------------------------------------------------------- Methodes publiques

    /**
     * Sauvegarder l'information entre dans un stockage persistent. 
     */
    public void saveToPersistentStore() {
		try {
			
			 /* Rcupration de la source de donnes  partir du contexte DataSource JNDI*/
			 
			Context context = new InitialContext();
			DataSource datasource = (DataSource) context.lookup("java:comp/env/jdbc/formation");
			
			/**
			 * Obtention d'une connexion du pool
			 */
			Connection cn = datasource.getConnection();
			
			/**
			 * Insertion en base
			 */
			Statement st = cn.createStatement();
			String sql = "INSERT INTO `hellostruts` (`personne`) VALUES ('"+ getPerson() +"')";			
			//Tracer la requte
			System.out.println(sql);			
			// insertion
			st.executeUpdate(sql);
			
		} catch (NamingException e) {
			e.printStackTrace();
		} catch (SQLException e) {
			e.printStackTrace();
		} 		
    }



}
